      Program CalcOptLim
C Sample use of UpperLim.f
C Get data from a file named "ULinput".  See FillFC below for its format.
C Append the results to the end of a file named "ULoutput".
C Compile with
C  f77 -o CalcOptLim2 CalcOptLim2.f UpperLimNew2.f y_vs_CLf2.f CMaxinfNew2.f ConfLev2.f ConfLevNew2.f Cinf2.f CERN_Stuff2.f
C or "f77" -> "gfortran -frecord-marker=4".
      Implicit None
      Integer*8 If,N,Iflag,EP
      Real*8 sigma,mu0,sigma0,muB,CL,Mw,fc0
C     Must increase length FC if more than 50000 events!!!
      Real*8 UpperLim,FC(0:50000),FB(0:50000),El
      Common/UpperLimcom/EP(2),El(2)
      Open(unit=25,form='FORMATTED',file='ULoutput', access='APPEND')
      Call FillFC(FC,N,mu0,sigma0,Mw)
C Now fill the background vectors
C      Call FillFB(FB,muB)

      CL=0.9D0                    ! 90% Confidence level
      If=1                      ! fmin = 0.
      muB=0.D0                    ! Don't subtract background
      
C      fc0=UpperLim(CL,If,N,FC,muB,FC,Iflag,Ist,Ien)
      fc0=UpperLim(CL,If,N,FC,muB,FB,Iflag)

      sigma=(sigma0/mu0)*fc0
      El(1)=(sigma0/mu0)*El(1)
      El(2)=(sigma0/mu0)*El(2)
C      sigma = fc0

C     sigma is now the upper limit cross section.  Iflag is a status; 0 is good.
      Write(25,10) sigma,Mw,Iflag,EP(1),EP(2),El(1),El(2)
C     Write(25,20) FC
 10   Format(E13.6,F10.3,I5,I16,I16,E13.6,E13.6)
C     20   Format(E13.6)
      Stop
      End
C 
      Subroutine FillFC(FC,N,mu0,sigma0,Mw)
C FillFC reads from a table "ULinput" containing the events in order of
C increasing recoil energy.  For each event, the probability is given
C for the event having lower energy.  So, for example, suppose the
C distribution of events is expected to be uniform from 5 to 100 keV, and
C suppose there are 2 events, one at 10 keV and one at 50 keV.  Then
C given an event, it has probability (10-5)/(100-5) = 0.05263 of being
C below 10 keV and probability (50-5)/(100-5) = 0.47368 of being below
C 50 keV.  As an example, that's what I've put in the table.  Alternatively,
C I could have just said FC(1)=0.05263, FC(2)=.47368, N=2.
      Implicit None
      Real*8 mu0,Mw,sigma0
      Real*8 FC(0:50000) ! FC(I) contains the probability for the I'th event.
      Integer*8 N ! The number of events read in
      Open(unit=50,form='FORMATTED',status='OLD',file='ULinput')
      Read(50,30) sigma0
      Print *, sigma0
      Read(50,20) Mw
      Print *, Mw
      Read(50,30) mu0
      N=0
 10   continue
      N=N+1
      Read(50,30,END=100) FC(N)
 20   Format(F10.6)
      Go to 10
 30   Format(E12.6)
      Go to 10
 100  N = N-1
      Return
      End


      Subroutine FillFB(FB,muB)
C Same as FillFC, but for the background vectors
      Implicit None
      Real*8 muB
      Real*8 FB(0:50000) ! FB(I) contains the probability for the I'th event.
      Integer*8 N                 ! The number of events read in
      Open(unit=50,form='FORMATTED',status='OLD',file='BGinput')
      Read(50,30) muB
      N=0
 10   continue
      N=N+1
      Read(50,30,END=100) FB(N)
 20   Format(F10.6)
      Go to 10
 30   Format(E12.6)
      Go to 10
 100  N = N-1
      Return
      End
