      Program lite2Upper
C Uses ULinput, a table of all the events in the CDMSlite Run 2 analysis, to find the upper
C limit cross section as a function of mass.
C Compile with
C gfortran -frecord-marker=4 -o lite2Upper lite2Upper.f UpperLimNew2.f y_vs_CLf2.f CMaxinfNew2.f ConfLev2.f ConfLevNew2.f Cinf2.f CERN_Stuff2.f
C or
C f77 -o lite2Upper lite2Upper.f UpperLimNew2.f y_vs_CLf2.f CMaxinfNew2.f ConfLev2.f ConfLevNew2.f Cinf2.f CERN_Stuff2.f
C Assume ULinput consists of one line for each WIMP mass with sigma0, mass,
C mu0, FC(I) for I=1 to Nevts, where Nevts is found by 'wc ULinput' giving
C lines, words, characters, with Nevts = (words/lines) - 3.
C
      Implicit None
      Integer*8 If/1/, I, Nevts, N, Iflag
      Parameter (Nevts=318)
      Real*8 sigma0, mu0, fc0, sigma
      Real*8 Mw,FC(0:Nevts+1),CL/0.9D0/,UpperLim,FB(0:Nevts+1),muB/0.D0/
      Open(unit=24,form='FORMATTED',status='OLD',file='ULinput')
      Open(unit=26,form='FORMATTED',status='OLD',file='ULoutput')
 10   read(24,*,END=100) sigma0,Mw,mu0,(FC(I),I=1,Nevts)
C     write(6,20) sigma0,Mw,mu0,(FC(I),I=1,5)
 20   Format(D14.3,F7.3,6F8.4)
      FC(0)=0.
C Whenever there are > 99 events with FC(I) < 1 and fc0 comes out < 99, there
C are errors "Routine CnMax failed." with Iflag 64.  There is no error message,
C and iflag=0, if fc0 > 99, when the high statistics approximation is needed.
C
C ULinput has WIMP masses for which the FC goes to some maximum close to 1, but
C never rises after that.  Exclude all events after the first FC(I) > 0.9999
C in order to get rid of some of the Iflag=64 cases.
      N = Nevts
      Do I=1,Nevts
         If (FC(I).gt.0.9999) Then
            N=I
            Go to 25
         EndIf
      EndDo
 25   FC(N+1)=1.
      fc0=UpperLim(CL,If,N,FC,muB,FB,Iflag)
      sigma=(sigma0/mu0)*fc0
      Write(26,30) sigma,mW,iflag,N,fc0
 30   Format(D12.3,F7.3,2I4,F8.3)
      Go to 10
 100  stop
      end
